#ifndef _COMMAND_PARSER_APPEARED_
#define _COMMAND_PARSER_APPEARED_

#include <map>
#include <vector>
#include <string>

namespace euc
{

// н
class command_parser
{
public:
    command_parser(void);
    virtual ~command_parser(void);

public:
    // һӦ
    virtual bool parse(std::string token) = 0;
    // С
    virtual bool parse_all(int argc, const char *argv[]);
    // ϡ
    virtual bool finish(void);

protected:
    // Ϊ param ѡһ value
    //  param ѡڣԶ
    void add(std::string param, std::string value);
    // Ϊ param ѡһ value
    //  param ѡڣԶ
    void add(const char *param, const char *value);

public:
    // ȡ param ѡµĲ
    // ѡڣ򷵻ؿ vector
    const std::vector<std::string> &get(std::string param) const;
    // ȡ param ѡµĲ
    // ѡڣ򷵻ؿ vector
    const std::vector<std::string> &get(const char *param) const;
    // ȡ param ѡµĲ
    // ѡڣ򷵻ؿ vector
    const std::vector<std::string> &operator[](std::string param) const;
    // ȡ param ѡµĲ
    // ѡڣ򷵻ؿ vector
    const std::vector<std::string> &operator[](const char *param) const;

private:
    std::map<std::string, std::vector<std::string> > _params;
    static std::vector<std::string> _nill;
};

// Ϊ param ѡһ value
//  param ѡڣԶ
inline void command_parser::add(const char *param, const char *value)
{
    add(std::string(param), std::string(value));
}

// ȡ param ѡµĲ
// ѡڣ򷵻ؿ vector
inline const std::vector<std::string> &command_parser::get
    (const char *param) const
{
    return get(std::string(param));
}

// ȡ param ѡµĲ
// ѡڣ򷵻ؿ vector
inline const std::vector<std::string> &command_parser::operator[]
    (std::string param) const
{
    return get(param);
}

// ȡ param ѡµĲ
// ѡڣ򷵻ؿ vector
inline const std::vector<std::string> &command_parser::operator[]
    (const char *param) const
{
    return get(param);
}

} // namespace

#endif // _COMMAND_PARSER_APPEARED_
