/*  ʵ(EUC)Ա ļ
    Ȩ(C)  2003

    һ GNU ͨù
֤޸ĺ·һ򡣻֤ĵڶ棬ߣѡ
κθµİ汾
    һĿϣãûκεûʺضĿ
ĵĵϸ GNU ͨù֤
    ӦѾͳһյһ GNU ͨù֤ĸûУ
дŸ
    The Free Software Foundation, Inc.,  675  Mass Ave,  Cambridge,
    MA02139,  USA

    ڱʲô⣬ϵ
    E-mailedyfox@sohu.com */
#include "config_file.h"

namespace euc
{

const int MAX_LINE = 4096;

config_file::config_file(const char *filename)
    : _dirty_flag(false), _loaded(false)
{
    if (filename)
        attach(filename);
}

config_file::config_file(const std::string &filename)
    : _filename(filename), _dirty_flag(false), _loaded(false)
{
    attach(filename);
}

config_file::~config_file(void)
{
    detach();
}

// ļ
bool config_file::attach(const char *filename)
{
    return attach(std::string(filename));
}

// ļ
bool config_file::attach(const std::string &filename)
{
    detach();
    _filename = filename;
    return load();
}

// ͷ
bool config_file::detach(void)
{
    bool result = true;
    if (_filename.size())
        result = save();
    _filename = "";
    return result;
}

// ȡֵ
std::string config_file::get_value(const std::string &section,
    const std::string &key) const
{
    SYNCHRONIZED(_lock);
    _map_type::const_iterator ite;
    if ((ite = _map.find(section)) == _map.end())
        return std::string();

    std::multimap<std::string, _record>::const_iterator pos;
    if ((pos = ite->second.find(key)) == ite->second.end())
        return std::string();

    return pos->second.value;
}

// ȡֵ
std::string config_file::get_value(const char *section,
    const char *key) const
{
    return get_value(std::string(section), std::string(key));
}

// ȡֵ
int config_file::get_value(const std::string &section,
    const std::string &key, int) const
{
    return atoi(get_value(section, key).c_str());
}

// ȡֵ
int config_file::get_value(const char *section,
    const char *key, int) const
{
    return get_value(std::string(section), std::string(key), 0);
}

// ȡֵ
double config_file::get_value(const std::string &section,
    const std::string &key, double) const
{
    return atof(get_value(section, key).c_str());
}

// ȡֵ
double config_file::get_value(const char *section,
    const char *key, double) const
{
    return get_value(std::string(section), std::string(key), 0.0);
}

// ȡֵ
std::vector<std::string> config_file::get_multiple_value
    (const std::string &section, const std::string &key) const
{
    SYNCHRONIZED(_lock);
    _map_type::const_iterator ite;
    if ((ite = _map.find(section)) == _map.end())
        return std::vector<std::string>();

    std::pair<std::multimap<std::string, _record>::const_iterator,
    std::multimap<std::string, _record>::const_iterator>
        pos = ite->second.equal_range(key);
    if (pos.first == pos.second)
        return std::vector<std::string>();

    std::vector<std::string> result;
    while (pos.first != pos.second)
        result.push_back(pos.first++->second.value);

    return result;
}

// ȡֵ
std::vector<std::string> config_file::get_multiple_value
    (const char *section, const char *key) const
{
    return get_multiple_value(std::string(section), std::string(key));
}

// дֵ
void config_file::set_value(const std::string &section,
                            const std::string &key,
                            const std::string &value)
{
    SYNCHRONIZED(_lock);
    if (section == "" || key == "")
        return;

    _map_type::iterator ite;
    if ((ite = _map.find(section)) == _map.end())
    {
        _add_value(section, key, value);
        return;
    }

    std::multimap<std::string, _record>::const_iterator pos;
    if ((pos = ite->second.find(key)) == ite->second.end())
    {
        _add_value(section, key, value);
        return;
    }

    std::string *modifier = (std::string *) &(pos->second.value);
    *modifier = value;

    if (pos->second.addition)
        pos->second.addition->second = value;

    pos->second.pointer->modified = true;

    _dirty_flag = true;
}

// дֵ
void config_file::set_value(const char *section,
                            const char *key,
                            const char *value)
{
    set_value(std::string(section), std::string(key), std::string(value));
}

// дֵ
void config_file::set_value(const std::string &section,
                            const std::string &key,
                            const int value)
{
    char buffer[256];
    sprintf(buffer, "%d", value);
    set_value(section, key, std::string(buffer));
}

// дֵ
void config_file::set_value(const char *section,
                            const char *key,
                            const int value)
{
    set_value(std::string(section), std::string(key), value);
}

// дֵ
void config_file::set_value(const std::string &section,
                            const std::string &key,
                            const double value)
{
    char buffer[256];
    sprintf(buffer, "%g", value);
    set_value(section, key, std::string(buffer));
}

// дֵ
void config_file::set_value(const char *section,
                            const char *key,
                            const double value)
{
    set_value(std::string(section), std::string(key), value);
}

// дֵ
void config_file::set_value(const std::string &section,
                            const std::string &key,
                            const std::string &old_value,
                            const std::string &value)
{
    SYNCHRONIZED(_lock);
    _map_type::iterator ite;
    if ((ite = _map.find(section)) == _map.end())
    {
        _add_value(section, key, value);
        return;
    }

    std::pair<std::multimap<std::string, _record>::const_iterator,
        std::multimap<std::string, _record>::const_iterator> pos
        = ite->second.equal_range(key);

    while (pos.first != pos.second)
    {
        if (pos.first->second.value == old_value)
        {
            std::string *modifier =
                (std::string *) &(pos.first->second.value);
            *modifier = value;

            if (pos.first->second.addition)
                pos.first->second.addition->second = value;

            pos.first->second.pointer->modified = true;
            _dirty_flag = true;

            return;
        }

        ++(pos.first);
    }

    _add_value(section, key, value);
}

// дֵ
void config_file::set_value(const char *section,
                            const char *key,
                            const char *old_value,
                            const char *value)
{
    set_value(std::string(section), std::string(key),
        std::string(old_value), std::string(value));
}

// дֵ
void config_file::set_value(const std::string &section,
                            const std::string &key,
                            const int old_value,
                            const int value)
{
    char buffer1[256];
    sprintf(buffer1, "%d", old_value);
    char buffer2[256];
    sprintf(buffer2, "%d", value);
    set_value(section, key, std::string(buffer1), std::string(buffer2));
}

// дֵ
void config_file::set_value(const char *section,
                            const char *key,
                            const int old_value,
                            const int value)
{
    set_value(std::string(section), std::string(key), old_value, value);
}

// дֵ
void config_file::set_value(const std::string &section,
                            const std::string &key,
                            const double old_value,
                            const double value)
{
    char buffer1[256];
    sprintf(buffer1, "%g", old_value);
    char buffer2[256];
    sprintf(buffer2, "%g", value);
    set_value(section, key, std::string(buffer1), std::string(buffer2));
}

// дֵ
void config_file::set_value(const char *section,
                            const char *key,
                            const double old_value,
                            const double value)
{
    set_value(std::string(section), std::string(key), old_value, value);
}

// ɾֵ
bool config_file::remove_key(const std::string &section,
                             const std::string &key)
{
    SYNCHRONIZED(_lock);
    _map_type::iterator ite;
    if ((ite = _map.find(section)) == _map.end())
        return false;

    std::pair<std::multimap<std::string, _record>::const_iterator,
        std::multimap<std::string, _record>::const_iterator> pos
        = ite->second.equal_range(key);

    while (pos.first != pos.second)
    {
        _remove(section, pos.first);
        ++(pos.first);
    }

    _remove_addition(section, key);
    return true;
}

// ɾֵ
bool config_file::remove_key(const char *section,
                             const char *key)
{
    return remove_key(std::string(section), std::string(key));
}

// ɾֵ
bool config_file::remove_key(const std::string &section,
                             const std::string &key,
                             const std::string &value)
{
    _map_type::iterator ite;
    if ((ite = _map.find(section)) == _map.end())
        return false;

    std::pair<std::multimap<std::string, _record>::const_iterator,
        std::multimap<std::string, _record>::const_iterator> pos
        = ite->second.equal_range(key);

    while (pos.first != pos.second)
    {
        if (pos.first->second.value == value)
        {
            _remove(section, pos.first);
            return true;
        }
        ++(pos.first);
    }

    _remove_addition(section, key, value);
    return false;
}

// ɾֵ
bool config_file::remove_key(const char *section,
                             const char *key,
                             const char *value)
{
    return remove_key(std::string(section), std::string(key),
        std::string(value));
}

// ɾ
bool config_file::remove_section(const std::string &section)
{
    SYNCHRONIZED(_lock);
    _map_type::iterator ite = _map.find(section);
    if (ite == _map.end())
        return false;

    std::multimap<std::string, _record>::const_iterator pos
        = ite->second.begin();

    while (pos != ite->second.end())
    {
        _remove(section, pos);
        ++pos;
    }

    _map.erase(section);
    _addition.erase(section);

    std::list<_line>::iterator eraser = _file.begin();
    while (eraser != _file.end())
    {
        if (trim(eraser->content) == "[" + section + "]")
        {
            eraser->content = "";
            return true;
        }

        ++eraser;
    }

    return true;
}

// ɾ
bool config_file::remove_section(const char *section)
{
    return remove_section(std::string(section));
}

// öٶ
void config_file::enum_sections(bool (*enum_sections_proc)
    (const std::string &section))
{
    SYNCHRONIZED(_lock);
    _map_type::iterator ite = _map.begin();

    while (ite != _map.end())
    {
        if (ite->first == "")
            continue;

        if (!enum_sections_proc(ite->first))
            return;
        ++ite;
    }
}

// öټֵ
void config_file::enum_keys(const std::string &section,
    bool (*enum_keys_proc)(const std::string &key,
    const std::string &value))
{
    SYNCHRONIZED(_lock);
    _map_type::iterator pos = _map.find(section);
    if (pos == _map.end())
        return;

    std::multimap<std::string, _record>::iterator ite
        = pos->second.begin();

    while (ite != pos->second.end())
    {
        if (ite->first == "")
            continue;

        if (!enum_keys_proc(ite->first, ite->second.value))
            return;
        ++ite;
    }
}

// ļ
bool config_file::load(void)
{
    SYNCHRONIZED(_lock);
    if (_loaded)
        return true;
    _loaded = true;

    if (_filename.size() == 0)
        return false;

    std::fstream instream(_filename.c_str(), std::ios::in);
    if (!instream.good())
    {
        instream.close();
        return false;
    }

    char buffer[MAX_LINE];
    std::string section;

    while (instream.good())
    {
        instream.getline(buffer, MAX_LINE);
        std::string line(buffer);
        _line this_line;
        this_line.content = line;
        this_line.modified = false;
        this_line.pointer = NULL;
        _file.push_back(this_line);

        line = trim(line, " \t\r\n");
        if (line.size() == 0 || line[0] == ';')
            continue;

        if (line[0]=='[')
        {
            std::string::size_type pos = line.find(']');
            if (pos == std::string::npos)
                section = "";
            else
            {
                section = line.substr(1, pos - 1);
                _record record;
                record.value = "";
                record.pointer = &(_file.back());
                record.addition = NULL;
                _map[section].insert(std::make_pair(std::string(), record));
            }
        }
        else
        {
            std::string key, value;

            std::string::size_type pos = line.find('=');
            key = trim(line.substr(0, pos), " \t\r\n");

            if (pos != std::string::npos && pos != line.size() - 1)
                value = trim(line.substr(++pos), " \t\r\n");
            else
                value = "";

            _record record;
            record.value = value;
            record.pointer = &(_file.back());
            record.addition = NULL;
            std::multimap<std::string, _record>::iterator ite =
                (_map[section].insert(std::make_pair(key, record)));
            _file.back().pointer = &(*ite);
        }
    }

    return true;
}

// ¼ļ
bool config_file::reload(void)
{
    SYNCHRONIZED(_lock);
    _clear();
    _loaded = false;
    return load();
}

// ļ
bool config_file::save(void)
{
    SYNCHRONIZED(_lock);
    if (_filename.size() == 0)
        return false;

    if (!_dirty_flag)
        return true;

    std::fstream outstream(_filename.c_str(), std::ios::out);
    if (!outstream.good())
    {
        outstream.close();
        return false;
    }

    bool begin = true;
    std::string section;

    for (std::list<_line>::iterator line_ite = _file.begin();
        line_ite != _file.end(); ++line_ite)
    {
        if (line_ite->content.size() == 0 || trim(line_ite->content) == "")
            continue;

        if (line_ite->content[0] == '[')
        {
            std::string::size_type pos = line_ite->content.find(']');

            if (begin)
                begin = false;
            else
            {
                _dump_addition(outstream, section);
                outstream << std::endl;
            }

            if (pos == std::string::npos)
                section = "";
            else
                section = line_ite->content.substr(1, pos - 1);
        }

        if (!line_ite->modified || line_ite->pointer == NULL)
            outstream << line_ite->content << std::endl;
        else
        {
            outstream << line_ite->pointer->first << "="
                << line_ite->pointer->second.value << std::endl;
        }
    }

    _dump_addition(outstream, section);

    outstream.close();
    _dirty_flag = false;

    return true;
}

// Ӽֵ
void config_file::_add_value(const std::string &section,
                             const std::string &key,
                             const std::string &value)
{
    if (_map.find(section) == _map.end())
    {
        _line this_line;
        this_line.content = "[" + section + "]";
        this_line.modified = false;
        this_line.pointer = NULL;
        _file.push_back(this_line);
    }

    std::multimap<std::string, std::pair<std::string, std::string> >
        ::iterator ite = _addition.insert(std::make_pair(section,
        std::make_pair(key, value)));

    _record record;
    record.value = value;
    record.pointer = &(_file.back());
    record.addition = &(ite->second);
    _map[section].insert(std::make_pair(key, record));

    _dirty_flag = true;
}

void config_file::_remove(const std::string &section,
    std::multimap<std::string, _record>::const_iterator ite)
{
    _remove_addition(section, ite->first, ite->second.value);
    ite->second.pointer->content = "";
}

void config_file::_remove_addition(const std::string &section,
                                   const std::string &key)
{
    std::pair
        <std::multimap<std::string, std::pair<std::string, std::string> >
        ::iterator,
        std::multimap<std::string, std::pair<std::string, std::string> >
        ::iterator> range;
    range = _addition.equal_range(section);
    while (range.first != range.second)
    {
        if (key != range.first->second.first)
        {
            ++(range.first);
            continue;
        }

        std::multimap<std::string,
            std::pair<std::string, std::string> >::iterator temp =
            range.first;
        ++temp;
        _addition.erase(range.first);
        range.first = temp;
    }
}

void config_file::_remove_addition(const std::string &section,
                                   const std::string &key,
                                   const std::string &value)
{
    std::pair
        <std::multimap<std::string, std::pair<std::string, std::string> >
        ::iterator,
        std::multimap<std::string, std::pair<std::string, std::string> >
        ::iterator> range;
    range = _addition.equal_range(section);
    while (range.first != range.second)
    {
        if (key != range.first->second.first)
        {
            ++(range.first);
            continue;
        }

        if (value != range.first->second.second)
        {
            ++(range.first);
            continue;
        }

        std::multimap<std::string,
            std::pair<std::string, std::string> >::iterator temp =
            range.first;
        ++temp;
        _addition.erase(range.first);
        range.first = temp;
    }
}

void config_file::_dump_addition(std::ostream &outstream,
                                 std::string &section)
{
    std::pair
        <std::multimap<std::string, std::pair<std::string, std::string> >
        ::iterator,
        std::multimap<std::string, std::pair<std::string, std::string> >
        ::iterator> range;

    range = _addition.equal_range(section);

    while (range.first != range.second)
    {
        outstream << range.first->second.first << "="
            << range.first->second.second << std::endl;
        ++(range.first);
    }
}

void config_file::_clear(void)
{
    _file.clear();
    _addition.clear();
    _map.clear();
}

} // namespace
