/*  ʵ(EUC)Ա ļ
    Ȩ(C)  2003

    һ GNU ͨù
֤޸ĺ·һ򡣻֤ĵڶ棬ߣѡ
κθµİ汾
    һĿϣãûκεûʺضĿ
ĵĵϸ GNU ͨù֤
    ӦѾͳһյһ GNU ͨù֤ĸûУ
дŸ
    The Free Software Foundation, Inc.,  675  Mass Ave,  Cambridge,
    MA02139,  USA

    ڱʲô⣬ϵ
    E-mailedyfox@sohu.com */
#ifndef _CONFIG_FILE_APPEARED_
#define _CONFIG_FILE_APPEARED_

#if defined(_MSC_VER) && _MSC_VER < 1300
#pragma warning (disable: 4503)
#if defined(_DEBUG)
#pragma warning (disable: 4786)
#endif
#endif

#include <vector>
#include <list>
#include <map>
#include <string>
#include <fstream>
#include <cstdlib>
#include "stringutil.h"
#include "critical_section.h"

namespace euc
{

class config_file
{
public:
    config_file(const char *filename = NULL);
    config_file(const std::string &filename);
    virtual ~config_file(void);

    // ļ
    bool attach(const char *filename);
    // ļ
    bool attach(const std::string &filename);

    // ͷ
    bool detach(void);

    // ȡֵ
    virtual std::string get_value(const std::string &section,
        const std::string &key) const;
    // ȡֵ
    std::string get_value(const char *section,
        const char *key) const;

    // ȡֵ
    virtual int get_value(const std::string &section,
        const std::string &key, int) const;
    // ȡֵ
    int get_value(const char *section,
        const char *key, int) const;

    // ȡֵ
    virtual double get_value(const std::string &section,
        const std::string &key, double) const;
    // ȡֵ
    double get_value(const char *section,
        const char *key, double) const;

    // ȡֵ
    virtual std::vector<std::string> get_multiple_value
        (const std::string &section,
        const std::string &key) const;
    // ȡֵ
    std::vector<std::string> get_multiple_value
        (const char *section,
        const char *key) const;

    // дֵ
    virtual void set_value(const std::string &section,
        const std::string &key, const std::string &value);
    // дֵ
    void set_value(const char *section, const char *key,
        const char *value);

    // дֵ
    virtual void set_value(const std::string &section,
        const std::string &key, const int value);
    // дֵ
    void set_value(const char *section, const char *key,
        const int value);

    // дֵ
    virtual void set_value(const std::string &section,
        const std::string &key, const double value);
    // дֵ
    void set_value(const char *section, const char *key,
        const double value);

    // дֵ
    virtual void set_value(const std::string &section,
        const std::string &key, const std::string &old_value,
        const std::string &value);
    // дֵ
    void set_value(const char *section, const char *key,
        const char *old_value, const char *value);

    // дֵ
    virtual void set_value(const std::string &section,
        const std::string &key, const int old_value, const int value);
    // дֵ
    void set_value(const char *section, const char *key,
        const int old_value, const int value);

    // дֵ
    virtual void set_value(const std::string &section,
        const std::string &key, const double old_value, const double value);
    // дֵ
    void set_value(const char *section, const char *key,
        const double old_value, const double value);

    // ɾֵ
    virtual bool remove_key(const std::string &section,
        const std::string &key);
    // ɾֵ
    bool remove_key(const char *section, const char *key);
    // ɾֵ
    virtual bool remove_key(const std::string &section,
        const std::string &key, const std::string &value);
    // ɾֵ
    bool remove_key(const char *section, const char *key,
        const char *value);

    // ɾ
    virtual bool remove_section(const std::string &section);
    // ɾ
    bool remove_section(const char *section);

    // öٶ
    void enum_sections(bool (*enum_sections_proc)
        (const std::string &section));
    // öټֵ
    void enum_keys(const std::string &section,
        bool (*enum_keys_proc)(const std::string &key,
        const std::string &value));

    // ļ
    virtual bool save(void);
    // ļ
    virtual bool load(void);
    // ¼ļ
    virtual bool reload(void);

private:
    struct _record;
    struct _line;

    struct _record
    {
        std::string value;
        _line *pointer;
        std::pair<std::string, std::string> *addition;
    };

    typedef std::map<std::string, std::multimap<std::string, _record> >
        _map_type;

    struct _line
    {
        std::string content;
        std::pair<const std::string, _record> *pointer;
        bool modified;
    };

    _map_type _map;
    std::list<_line> _file;
    std::string _filename;
    std::multimap<std::string, std::pair<std::string, std::string> >
        _addition;
    bool _dirty_flag;
    bool _loaded;

    // Ӽֵ
    virtual void _add_value(const std::string &section,
        const std::string &key, const std::string &value);
    // ɾֵ
    void _remove(const std::string &section,
        std::multimap<std::string, _record>::const_iterator ite);
    void _remove_addition(const std::string &section,
        const std::string &key);
    void _remove_addition(const std::string &section,
        const std::string &key, const std::string &value);
    // ӹļֵ
    void _dump_addition(std::ostream &outstream, std::string &section);
    //
    void _clear(void);

    // ߳ͬ
    mutable IMPLEMENT_SYNCHRONIZATION(_lock);
};

};

#endif
