/*  ʵ(EUC)Ա ԰ģ
    Ȩ(C)  2003

    һ GNU ͨù
֤޸ĺ·һ򡣻֤ĵڶ棬ߣѡ
κθµİ汾
    һĿϣãûκεûʺضĿ
ĵĵϸ GNU ͨù֤
    ӦѾͳһյһ GNU ͨù֤ĸûУ
дŸ
    The Free Software Foundation, Inc.,  675  Mass Ave,  Cambridge,
    MA02139,  USA

    ڱʲô⣬ϵ
    E-mailedyfox@sohu.com */
#include <fstream>
#include "fileutil.h"
#include "stringutil.h"
#include "language.h"

namespace euc
{

language::language(std::string name, const std::list<std::string> &folders,
    std::string def_token) : _def_token(def_token)
{
    // ȼطϵǰõ԰
    std::string locale_str = _locale_string();
    if (locale_str.size())
    {
        for (std::list<std::string>::const_iterator ite = folders.begin();
            ite != folders.end(); ++ite)
        {
            std::string filename;
            if ((*ite)[ite->size() - 1] != PATH_SEPARATOR)
                filename = *ite + PATH_SEPARATOR + name;
            else
                filename = *ite + name;
            filename += "_" + locale_str + ".lan";
            if (_load_data(filename))
                return;
        }
    }

    // Ĭ԰
    for (std::list<std::string>::const_iterator ite = folders.begin();
        ite != folders.end(); ++ite)
    {
        std::string filename;
        if ((*ite)[ite->size() - 1] != PATH_SEPARATOR)
            filename = *ite + PATH_SEPARATOR + name;
        else
            filename = *ite + name;
        filename += ".lan";
        if (_load_data(filename))
            return;
    }
}

language::~language(void)
{}

std::string language::get_string(std::string name)
{
    std::map<std::string, std::string>::iterator ite
        = _lang_map.find(name);

    if (ite != _lang_map.end())
        return ite->second;

    return _def_token;
}

bool language::_load_data(std::string filename)
{
    std::fstream *input = NULL;
    bool result = false;

    try
    {
        input = new std::fstream(filename.c_str(), std::ios::in);
        if (!input->good())
        {
            input->close();
            delete input;
            return false;
        }

        result = _read(*input);
    }
    catch (...)
    {
        input->close();
        delete input;
        return false;
    }

    input->close();
    delete input;

    return result;
}

std::string language::_unescape(std::string str)
{
    std::string result = euc::replace_all(str, "\\n", "\n");
    result = euc::replace_all(result, "\\t", "\t");
    result = euc::replace_all(result, "\\\"", "\"");
    result = euc::replace_all(result, "\\\'", "\'");
    result = euc::replace_all(result, "\\\\", "\\");
    return result;
}

bool language::_read(std::istream &input)
{
    char buffer[16384];
    while (input.good())
    {
        input.getline(buffer, 16384);
        std::string line(buffer);

        line = euc::rtrim(euc::ltrim(line, std::string(" \t\r\n")),
                std::string("\r\n"));
        if (line[0] == line[line.size() - 1]
            && (line[0] == '\'' || line[0] == '\"'))
            line = line.substr(1, line.size() - 2);

        // ųע
        if (line[0] == ';' || line.size() == 0)
            continue;
        std::string::size_type pos = line.find('=');
        if (pos == std::string::npos)
            continue;

        std::string key = trim(line.substr(0, pos), std::string(" \t\r\n"));

        std::string value;
        if (pos < line.size() - 1)
            value = trim(line.substr(pos + 1), " \t\r\n");

        if (key.size() == 0)
            continue;

        _lang_map[key] = _unescape(value);
    }

    return true;
}

std::string language::_locale_string(void)
{
    char *env = getenv("LANG");
    if (env == NULL)
        return std::string();

    std::string result = env;
    std::string::size_type pos = result.find_first_of('.');

    if (pos == std::string::npos)
        return result;

    if (pos == 0 || pos == result.size() - 1)
        return std::string();

    return result.substr(0, pos);
}

} // namespace
